/*
  CPP_CONTEST=2018Qual
  CPP_PROBLEM=C
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=1
  CPP_NUM_NODES=1
*/

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <iomanip>    
#include <math.h>
//#include <helper_functions.h>
//#include <helper_cuda.h>

using namespace std;

void copy(int n,int *vd,int *vo)
{
  for(int i=0;i<n;i++)
    vd[i]=vo[i];
}
 
void update(int n,int *a,int *b,int row,int column)
{
   int element=a[row*n+column];
   int *da=&a[row*n+column];
   int *db=&b[row*n+column];
   for(int i=1;i<n-column;i++) //the previous elements in the same row have been compared in previous calls to the routine
   {
      if(element%da[i]==0 || da[i]%element==0)
      {
        db[0]+=da[i]; 
        db[i]+=da[0];
      }
   }
   for(int i=1;i<n-row;i++) //the previous elements in the same column have been compared in previous calls to the routine
   {
      if(element%da[i*n]==0 || da[i*n]%element==0)
      {
        db[0]-=da[i*n]; 
        db[i*n]-=da[0];
      }
   }
}

void  sec(int n,int *a)
{
  int *b=(int *) calloc(sizeof(int),n*n); //to store the updated values
  for(int i=0;i<n;i++) 
  {
    for(int j=0;j<n;j++)
       update(n,a,b,i,j); 
  }
  copy(n*n,a,b);
  free(b);
}

