#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <omp.h>
#include <signal.h>
#include <unistd.h>
#include <iostream>
#include <iomanip>
#include <math.h>

using namespace std;

// Scheme for the problem of Sums between two values - OpenMP version
// Qualification contest for the Spanish Parallel Programming Contest 2018, problem F

//initialize a vector
void inicialize(int n,int *m,int lv,int uv)
{
    for(int i=0;i<n;i++)
      m[i]=int(((1.*rand())/RAND_MAX)*(uv-lv)+lv);
}

//write a matrix, only for debug
void escribir(int n,int m,int *a){
  for (int i = 0; i < n; i++)
  {
      for(int j=0;j<m;j++)
           cout << a[i*m+j]<<" ";
      cout <<endl; 
 }
  cout <<endl;
}

/*
c
c     mseconds - returns elapsed milliseconds since Jan 1st, 1970.
c
*/
long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000 + t.tv_usec/1000;
}

//abort with the maximum execution time is reached
static void alarm_handler(int sig) {
  fprintf(stderr, "Time Limit Exceeded\n");
  abort();
}

//the external function to be parallelized by the contestants
extern int sec(int,int *,int,int);

int main(int argc,char *argv[]) {
  int num_problems; //number of problems  
  int N; //number of natural numbers
  int *V; //values of the numbers
  int seed; //seed for random generation  
  int lower_value;  //lower bound for the values in the vector
  int upper_value;  //upper bound for the values in the vector
  int C1,C2; //interval for the number of sums
  long long ti,tf,tt=0; //initial, final and total times
  FILE *stats_file = fopen("stats", "w");

//to stablish a time limit
  struct sigaction sact;
  sigemptyset(&sact.sa_mask);
  sact.sa_flags = 0;
  sact.sa_handler = alarm_handler;
  sigaction(SIGALRM, &sact, NULL);
  alarm(100);  /* time limit */
 
//  MPI_Init(&argc,&argv);
//  MPI_Comm_size(MPI_COMM_WORLD,&np);
//  MPI_Comm_rank(MPI_COMM_WORLD,&nodo);

// The number of test cases is read
// and sent to all the processes
//  if(nodo==0)
//  {
    cin >> num_problems;
//    MPI_Bcast(&cuantos,1,MPI_INT,0,MPI_COMM_WORLD);
//  }
//  else
//  {
//    MPI_Bcast(&cuantos,1,MPI_INT,0,MPI_COMM_WORLD);
//  }
  for(int i=0;i<num_problems;i++)
  {
//    if(nodo==0)
//    {
      cin >>N;                   // The first argument is the size of the vector
      cin >>seed; //seed for the random generation of data to generate
      cin >>lower_value;  //lower bound for the values in the vector
      cin >>upper_value;  //upper bound for the values in the vector
      cin >> C1 >> C2;
// Space for the data
      V = new int[N];
      inicialize(N,V,lower_value,upper_value);
      

      srand(seed);

#ifdef DEBUG
// While debugging the vector written
      escribir(1,N,V);
#endif


//    }
//    MPI_Barrier(MPI_COMM_WORLD);
    ti=mseconds(); 
    int result=sec(N,V,C1,C2);
//    MPI_Barrier(MPI_COMM_WORLD);
    tf=mseconds(); 
//    if(nodo==0)
//    {
// The time of the first input is not considered
      if(i!=0) tt+=tf-ti;
#ifdef DEBUG
// While debugging the time of each execution is written
      fprintf(stats_file, "%Ld\n", tf-ti);
#endif
// The results of each problem are written,
// even for the first problem
      cout <<result<<endl;
      delete[] V;
//    } */
  }
  

//  if(nodo==0)
//  { 
    fprintf(stats_file, "%Ld\n", tt);
    fclose(stats_file);
//  }
//  MPI_Finalize();
  return 0;
}
